home *** CD-ROM | disk | FTP | other *** search
/ Skunkware 98 / Skunkware 98.iso / src / fileutil / tar-1.12.tar.gz / tar-1.12.tar / tar-1.12 / scripts / level-1 < prev    next >
Text File  |  1997-04-24  |  7KB  |  204 lines

  1. #!/bin/sh
  2. #
  3. # Run this script as root on the machine that has the tape drive, to make a
  4. # level-1 dump containing all files changed since the last full dump.
  5. #
  6. # If you give `now' as an argument, the dump is done immediately.
  7. # Otherwise, it waits until 1am.
  8. #
  9. # You must edit the file `backup-specs' to set the parameters for your site.
  10.  
  11. # Useful for backup-specs, in case things have to be done slightly
  12. # differently for different dump levels.
  13. DUMP_LEVEL=1
  14.  
  15. # Insure `mail' is in PATH.
  16. PATH="/usr/ucb:${PATH}"
  17. export PATH
  18.  
  19. # This is not the most reliable test in the world.  The following might be
  20. # more predictable:
  21. #
  22. # whoami="`whoami`"
  23. # euid="`sed -ne '/^'\"${whoami}\"':/{s/^[^:]*:[^:]*://;s/:.*//p;q;}' /etc/passwd`"
  24. # if [ "${euid}" != 0 ]; then ...
  25. #
  26. if [ ! -w / ]; then
  27.    echo "The backup must be run as root or else some files will fail to be dumped."
  28.    exit 1
  29. fi
  30.  
  31. # Get the values of BACKUP_DIRS, BACKUP_FILES, and other variables.
  32. . ./backup-specs
  33.  
  34. # Maybe sleep until around specified or default hour.
  35. if [ "z${1}" != "znow" ]; then
  36.    if [ "${1}x" != "x" ]; then
  37.       spec="${1}"
  38.    else
  39.       spec="${BACKUP_HOUR}"
  40.    fi
  41.  
  42.    pausetime="`date | awk '
  43.      {
  44.       hr = substr($4, 1, 2);
  45.       mn = substr($4, 4, 2);
  46.       if((hr + 0) < (spec + 0))
  47.          print 3600 * (spec - hr) - 60 * mn;
  48.       else
  49.          print 3600 * (spec + (24 - hr)) - 60 * mn;
  50.      }' spec=\"${spec}\"`"
  51.  
  52.    clear
  53.    echo "${SLEEP_MESSAGE}"
  54.    sleep "${pausetime}"
  55. fi
  56.  
  57. # start doing things
  58.  
  59. # Put startdate in the subject line of mailed report, since if it happens
  60. # to run longer than 24 hours (as may be the case if someone forgets to put
  61. # in the next volume of the tape in adequate time), the backup date won't
  62. # appear too misleading.
  63. startdate="`date`"
  64.  
  65. here="`pwd`"
  66.  
  67. # Logfile name should be in the form  ``log-1993-03-18-level-1''
  68. # They go in the subdirectory `log' of the current directory.
  69. # i.e. year-month-date.  This format is useful for sorting by name, since
  70. # logfiles are intentionally kept online for future reference.
  71. LOGFILE="log/log-`date | sed -ne '
  72.    s/[^ ]*  *\([^ ]*\)  *\([^ ]*\).* \([^ ]*\)$/\3-\1-\2/
  73.    /-[0-9]$/s/\([0-9]\)$/0\1/
  74.    /Jan/{s/Jan/01/p;q;}
  75.    /Feb/{s/Feb/02/p;q;}
  76.    /Mar/{s/Mar/03/p;q;}
  77.    /Apr/{s/Apr/04/p;q;}
  78.    /May/{s/May/05/p;q;}
  79.    /Jun/{s/Jun/06/p;q;}
  80.    /Jul/{s/Jul/07/p;q;}
  81.    /Aug/{s/Aug/08/p;q;}
  82.    /Sep/{s/Sep/09/p;q;}
  83.    /Oct/{s/Oct/10/p;q;}
  84.    /Nov/{s/Nov/11/p;q;}
  85.    /Dec/{s/Dec/12/p;q;}'`-level-${DUMP_LEVEL}"
  86.  
  87. localhost="`hostname | sed -e 's/\..*//'`"
  88.  
  89. TAR_PART1="${TAR} -c --multi-volume --one-file-system --blocking=${BLOCKING} --sparse --volno-file=${VOLNO_FILE}"
  90.  
  91. # Only use --info-script if DUMP_REMIND_SCRIPT was defined in backup-specs
  92. if [ "x${DUMP_REMIND_SCRIPT}" != "x" ]; then
  93.    TAR_PART1="${TAR_PART1} --info-script='${DUMP_REMIND_SCRIPT}'"
  94. fi
  95.  
  96. # Make sure the log file did not already exist.  Create it.
  97.  
  98. if [ -f "${LOGFILE}" ] ; then
  99.    echo "Log file ${LOGFILE} already exists." 1>&2
  100.    exit 1
  101. else
  102.    touch "${LOGFILE}"
  103. fi
  104.  
  105. # Most everything below here is run in a subshell for which all output is
  106. # piped through `tee' to the logfile.  Doing this, instead of having
  107. # multiple pipelines all over the place, is cleaner and allows access to
  108. # the exit value from various commands more easily.
  109. (
  110.  # Caveat: Some version of `mt' require `-t', not `-f'.
  111.  mt -f "${TAPE_FILE}" rewind
  112.  rm -f "${VOLNO_FILE}"
  113.  
  114.  set - ${BACKUP_DIRS}
  115.  while [ $# -ne 0 ] ; do
  116.     date="`date`"
  117.     remotehost="`echo \"${1}\" | sed -e 's/:.*$//'`"
  118.     fs="`echo \"${1}\" | sed -e 's/^.*://'`"
  119.     fsname="`echo \"${1}\" | sed -e 's/\//:/g'`"
  120.  
  121.     # This filename must be absolute; it is opened on the machine that runs tar.
  122.     TAR_PART2="--listed=/etc/tar-backup/temp.level-1"
  123.     TAR_PART3="--label='level 1 backup of ${fs} on ${remotehost} at ${date}' -C ${fs} ."
  124.  
  125.     echo "Backing up ${1} at ${date}"
  126.     echo "Last full dump on this filesystem:"
  127.  
  128.     if [ "z${remotehost}" != "z${localhost}" ] ; then
  129.       rsh "${remotehost}" "ls -l /etc/tar-backup/${fsname}.level-0; \
  130.           cp /etc/tar-backup/${fsname}.level-0 /etc/tar-backup/temp.level-1"
  131.     else
  132.       ls -l "/etc/tar-backup/${fsname}.level-0"
  133.       cp "/etc/tar-backup/${fsname}.level-0" /etc/tar-backup/temp.level-1
  134.     fi
  135.  
  136.     # Actually back things up.
  137.  
  138.     if [ "z${remotehost}" != "z${localhost}" ] ; then
  139.        rsh "${remotehost}" ${TAR_PART1} -f "${localhost}:${TAPE_FILE}" ${TAR_PART2} ${TAR_PART3}
  140.     else
  141.        # Using `sh -c exec' causes nested quoting and shell substitution
  142.        # to be handled here in the same way rsh handles it.
  143.        sh -c "exec ${TAR_PART1} -f \"${TAPE_FILE}\" ${TAR_PART2} ${TAR_PART3}"
  144.     fi
  145.  
  146.     # `rsh' doesn't exit with the exit status of the remote command.  What
  147.     # stupid lossage.  TODO: think of a reliable workaround.
  148.     if [ $? -ne 0 ] ; then
  149.        echo "Backup of ${1} failed."
  150.        # I'm assuming that the tar will have written an empty
  151.        # file to the tape, otherwise I should do a cat here.
  152.     else
  153.        if [ "z${localhost}" != "z${remotehost}" ] ; then
  154.          rsh "${remotehost}" mv -f /etc/tar-backup/temp.level-1 "/etc/tar-backup/${fsname}.level-1"
  155.        else
  156.          mv -f /etc/tar-backup/temp.level-1 "/etc/tar-backup/${fsname}.level-1"
  157.        fi
  158.     fi
  159.     ${TAPE_STATUS}
  160.     sleep 60
  161.     shift
  162.  done
  163.  
  164.  # Dump any individual files requested.
  165.  
  166.  if [ "x${BACKUP_FILES}" != "x" ] ; then
  167.     date="`date`"
  168.     TAR_PART2="--listed=/etc/tar-backup/temp.level-1"
  169.     TAR_PART3="--label='Incremental backup of miscellaneous files at ${date}'"
  170.  
  171.     echo "Backing up miscellaneous files at ${date}"
  172.     echo "Last full dump of these files:"
  173.     ls -l /etc/tar-backup/misc.level-0
  174.  
  175.     rm -f /etc/tar-backup/temp.level-1
  176.     cp /etc/tar-backup/misc.level-0 /etc/tar-backup/temp.level-1
  177.  
  178.     # Using `sh -c exec' causes nested quoting and shell substitution
  179.     # to be handled here in the same way rsh handles it.
  180.     sh -c "exec ${TAR_PART1} -f \"${TAPE_FILE}\" ${TAR_PART2} ${TAR_PART3} ${BACKUP_FILES}"
  181.  
  182.     if [ $? -ne 0 ] ; then
  183.       echo "Backup of miscellaneous files failed." 1>&2
  184.       # I'm assuming that the tar will have written an empty
  185.       # file to the tape, otherwise I should do a cat here.
  186.     else
  187.       mv -f /etc/tar-backup/temp.level-1 /etc/tar-backup/misc.level-1
  188.     fi
  189.     ${TAPE_STATUS}
  190.  else
  191.     echo "No miscellaneous files specified"
  192.  fi
  193.  
  194.  # Caveat: some versions of `mt' use `-t' instead of `-f'.
  195.  mt -f "${TAPE_FILE}" rewind
  196.  mt -f "${TAPE_FILE}" offl
  197.  
  198. ) 2>&1 | tee -a "${LOGFILE}"
  199.  
  200. echo "Sending the dump log to ${ADMINISTRATOR}"
  201. mail -s "Results of backup started ${startdate}" ${ADMINISTRATOR} < "${LOGFILE}"
  202.  
  203. # eof
  204.